/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// FlowOperationInnerJoin - struct for FlowOperationInnerJoin
type FlowOperationInnerJoin struct {
	FlowOperationInnerJoin *FlowOperationInnerJoin
}

// FlowOperationInnerJoinAsFlowOperationInnerJoin is a convenience function that returns FlowOperationInnerJoin wrapped in FlowOperationInnerJoin
func FlowOperationInnerJoinAsFlowOperationInnerJoin(v *FlowOperationInnerJoin) FlowOperationInnerJoin {
	return FlowOperationInnerJoin{
		FlowOperationInnerJoin: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *FlowOperationInnerJoin) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into FlowOperationInnerJoin
	err = newStrictDecoder(data).Decode(&dst.FlowOperationInnerJoin)
	if err == nil {
		jsonFlowOperationInnerJoin, _ := json.Marshal(dst.FlowOperationInnerJoin)
		if string(jsonFlowOperationInnerJoin) == "{}" { // empty struct
			dst.FlowOperationInnerJoin = nil
		} else {
			match++
		}
	} else {
		dst.FlowOperationInnerJoin = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.FlowOperationInnerJoin = nil

		return fmt.Errorf("data matches more than one schema in oneOf(FlowOperationInnerJoin)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(FlowOperationInnerJoin)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src FlowOperationInnerJoin) MarshalJSON() ([]byte, error) {
	if src.FlowOperationInnerJoin != nil {
		return json.Marshal(&src.FlowOperationInnerJoin)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *FlowOperationInnerJoin) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.FlowOperationInnerJoin != nil {
		return obj.FlowOperationInnerJoin
	}

	// all schemas are nil
	return nil
}

type NullableFlowOperationInnerJoin struct {
	value *FlowOperationInnerJoin
	isSet bool
}

func (v NullableFlowOperationInnerJoin) Get() *FlowOperationInnerJoin {
	return v.value
}

func (v *NullableFlowOperationInnerJoin) Set(val *FlowOperationInnerJoin) {
	v.value = val
	v.isSet = true
}

func (v NullableFlowOperationInnerJoin) IsSet() bool {
	return v.isSet
}

func (v *NullableFlowOperationInnerJoin) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlowOperationInnerJoin(val *FlowOperationInnerJoin) *NullableFlowOperationInnerJoin {
	return &NullableFlowOperationInnerJoin{value: val, isSet: true}
}

func (v NullableFlowOperationInnerJoin) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlowOperationInnerJoin) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
